﻿using System;
using SmartVault.Core;
using SmartVault.Proto;
using SmartVault.Rest;
using System.IO;

namespace HelloWorldSVRest
{
    class SmartVault
    {
        private PublicClientProtocol _protocol;
        private DelegatedProtocol _delegation;

        public SmartVault()
        {
            string clientId = "CSharpTutorial"; // Change this to your client ID
            PublicClientCfg cfg =
                new PublicClientCfg(new Uri("https://rest.smartvault.com"), clientId);
            _protocol = new PublicClientProtocol(cfg);
        }

        public string RequestPin(string email)
        {
            return _protocol.GetPinRequestEndpoint(email);
        }

        public void Authenticate(string email, string pin)
        {
            _delegation = _protocol.CreateDelegatedProtocol(email, pin);
        }

        public NodeResponse BrowsePath(string path)
        {
            int children = 1;  // Immediate contents only
            return _delegation.Navigate(new AbsolutePath(path), children);
        }

        public void UploadFile(string localFile, string remoteFolder)
        {
            FileStream stream = new FileStream(localFile, FileMode.Open);

            UploadFileRequest.Builder builder = UploadFileRequest.CreateBuilder();
            builder.Name = Path.GetFileName(localFile);

            _delegation.PostFile(new AbsolutePath(remoteFolder), builder.Build(), stream);

            stream.Close();
        }
    }
}
